import "Eldirin.LootFilter.AddWindow"

OptionsWindow=class(Turbine.UI.Lotro.Window)

addWindow = Eldirin.LootFilter.AddWindow();

listboxBackground = Turbine.UI.Color(1, 0.06, 0.06, 0.06);

function OptionsWindow:Constructor()
	x=Turbine.UI.Display:GetWidth()/2-100;
	y=Turbine.UI.Display:GetHeight()/2-100;
	Turbine.UI.Lotro.Window.Constructor(self);
	self:SetSize(580,430);
	self:SetPosition(x,y);
	self:SetText("LootFilter Options"); 

	addWindow.parentWindow = self;

	-- trigger Label
	self.triggerLabel = Turbine.UI.Label();
	self.triggerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.triggerLabel:SetParent(self);
    self.triggerLabel:SetSize(230, 20);
    self.triggerLabel:SetPosition(30, 40);
    self.triggerLabel:SetText("Triggers");
    self.triggerLabel:SetForeColor(Turbine.UI.Color(1, 0.90, 0.90, 0.40));


	-- trigger listbox
	self.triggerlistBox = Turbine.UI.ListBox();
	self.triggerlistBox:SetParent(self);
	self.triggerlistBox:SetHeight( 300 );
	self.triggerlistBox:SetWidth( 230 );
	self.triggerlistBox:SetMouseVisible( true );
	self.triggerlistBox:SetPosition(30 , 80);
	self.triggerlistBox:SetVisible(true);
	self.triggerlistBox:SetBackColor(listboxBackground);

	-- action for selecting a trigger
	self.triggerlistBox.SelectedIndexChanged = function( sender, args )
		self:SelectTrigger(sender:GetSelectedIndex());
	end
	
	-- scrollbar for triggerlistBox
	self.triggerlistScroll = Turbine.UI.Lotro.ScrollBar();
	self.triggerlistScroll:SetParent( self );
	self.triggerlistScroll:SetOrientation( Turbine.UI.Orientation.Vertical );
	self.triggerlistScroll:SetPosition(260, self.triggerlistBox:GetTop())
	self.triggerlistScroll:SetHeight(self.triggerlistBox:GetHeight() );
	self.triggerlistScroll:SetZOrder(310);
	self.triggerlistScroll:SetWidth( 10 );
	self.triggerlistScroll:SetValue( 0 );
	self.triggerlistBox:SetVerticalScrollBar( self.triggerlistScroll );

	-- add trigger button
	self.addBtn = Turbine.UI.Lotro.Button();
	self.addBtn:SetParent(self);
	self.addBtn:SetPosition(30,390);
	self.addBtn:SetSize(60,20);
	self.addBtn:SetText("add");
	self.addBtn:SetVisible(true);
	self.addBtn.MouseDown = function(sender,args)
		addWindow:StartAddProcess("trigger");
	end

	-- delete trigger button
	self.deleteBtn = Turbine.UI.Lotro.Button();
	self.deleteBtn:SetParent(self);
	self.deleteBtn:SetPosition(90,390);
	self.deleteBtn:SetSize(60,20);
	self.deleteBtn:SetText("delete");
	self.deleteBtn.MouseDown = function(sender,args)
		DeleteTrigger(self.selectedTrigger:GetText());
		SaveSettings();
		self:FillTrigger();
	end

	-- default trigger button
	self.defaultBtn = Turbine.UI.Lotro.Button();
	self.defaultBtn:SetParent(self);
	self.defaultBtn:SetPosition(150,390);
	self.defaultBtn:SetSize(60,20);
	self.defaultBtn:SetText("default");
	self.defaultBtn.MouseDown = function(sender,args)
		SetDefaultTrigger();
		SaveSettings();
		self:FillTrigger();
	end

	-- clear trigger button
	self.clearBtn = Turbine.UI.Lotro.Button();
	self.clearBtn:SetParent(self);
	self.clearBtn:SetPosition(210,390);
	self.clearBtn:SetSize(60,20);
	self.clearBtn:SetText("clear");
	self.clearBtn.MouseDown = function(sender,args)
		ClearTrigger();
		SaveSettings();
		self:FillTrigger();
	end

	-- blacklist Label
	self.blacklistLabel = Turbine.UI.Label();
	self.blacklistLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.blacklistLabel:SetParent(self);
    self.blacklistLabel:SetSize(230, 20);
    self.blacklistLabel:SetPosition(320, 40);
    self.blacklistLabel:SetText("Blacklist");
    self.blacklistLabel:SetForeColor(Turbine.UI.Color(1, 0.90, 0.90, 0.40));


	-- blacklist listbox
	self.blacklistListBox = Turbine.UI.ListBox();
	self.blacklistListBox:SetParent(self);
	self.blacklistListBox:SetHeight( 300 );
	self.blacklistListBox:SetWidth( 230 );
	self.blacklistListBox:SetMouseVisible( true );
	self.blacklistListBox:SetPosition(320 , 80);
	self.blacklistListBox:SetVisible(true);
	self.blacklistListBox:SetBackColor(listboxBackground);

	-- action for selecting a blacklist item
	self.blacklistListBox.SelectedIndexChanged = function( sender, args )
		self:SelectBlacklistItem(sender:GetSelectedIndex());
	end

	-- scrollbar for blacklistListBox
	self.blacklistScroll = Turbine.UI.Lotro.ScrollBar();
	self.blacklistScroll:SetParent( self );
	self.blacklistScroll:SetOrientation( Turbine.UI.Orientation.Vertical );
	self.blacklistScroll:SetPosition(self.blacklistListBox:GetLeft() + self.blacklistListBox:GetWidth(), self.blacklistListBox:GetTop())
	self.blacklistScroll:SetHeight(self.blacklistListBox:GetHeight() );
	self.blacklistScroll:SetZOrder(310);
	self.blacklistScroll:SetWidth( 10 );
	self.blacklistScroll:SetValue( 0 );
	self.blacklistListBox:SetVerticalScrollBar( self.blacklistScroll );

	-- add blacklist button
	self.addBtnBlacklist = Turbine.UI.Lotro.Button();
	self.addBtnBlacklist:SetParent(self);
	self.addBtnBlacklist:SetPosition(320,390);
	self.addBtnBlacklist:SetSize(60,20);
	self.addBtnBlacklist:SetText("add");
	self.addBtnBlacklist:SetVisible(true);
	self.addBtnBlacklist.MouseDown = function(sender,args)
		addWindow:StartAddProcess("blacklist");
	end

	-- delete trigger button
	self.deleteBtnBlacklist = Turbine.UI.Lotro.Button();
	self.deleteBtnBlacklist:SetParent(self);
	self.deleteBtnBlacklist:SetPosition(380,390);
	self.deleteBtnBlacklist:SetSize(60,20);
	self.deleteBtnBlacklist:SetText("delete");
	self.deleteBtnBlacklist.MouseDown = function(sender,args)
		DeleteFromBlacklist(self.selectedBlacklistItem:GetText());
		SaveSettings();
		self:FillBlacklist();
	end

	-- default trigger button
	self.defaultBtnBlacklist = Turbine.UI.Lotro.Button();
	self.defaultBtnBlacklist:SetParent(self);
	self.defaultBtnBlacklist:SetPosition(440,390);
	self.defaultBtnBlacklist:SetSize(60,20);
	self.defaultBtnBlacklist:SetText("default");
	self.defaultBtnBlacklist.MouseDown = function(sender,args)
		SetDefaultBlacklist();
		SaveSettings();
		self:FillBlacklist();
	end

	-- clear trigger button
	self.clearBtnBlacklist = Turbine.UI.Lotro.Button();
	self.clearBtnBlacklist:SetParent(self);
	self.clearBtnBlacklist:SetPosition(500,390);
	self.clearBtnBlacklist:SetSize(60,20);
	self.clearBtnBlacklist:SetText("clear");
	self.clearBtnBlacklist.MouseDown = function(sender,args)
		ClearBlacklist();
		SaveSettings();
		self:FillBlacklist();
	end


	self:FillTrigger();
	self:FillBlacklist();

	AddCallback(addWindow, "NewTriggerAdded", function()
		self:FillTrigger();
	end);

	AddCallback(addWindow, "NewBlacklistItemAdded", function()
		self:FillBlacklist();
	end);
end

function OptionsWindow:FillTrigger()
	self.triggerlistBox:ClearItems();
	for i = 1, table.getn(trigger) do
		local triggerItem = Turbine.UI.Label();
		triggerItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		triggerItem:SetText(trigger[i]);
		triggerItem:SetSize( 230, 20 );		
		self.triggerlistBox:AddItem(triggerItem);	
	end
end

function OptionsWindow:FillBlacklist()
	self.blacklistListBox:ClearItems();
	for i = 1, table.getn(blacklist) do
		local blacklistItem = Turbine.UI.Label();
		blacklistItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		blacklistItem:SetText(blacklist[i]);
		blacklistItem:SetSize( 230, 20 );		
		self.blacklistListBox:AddItem(blacklistItem);	
	end
end

function OptionsWindow:SelectTrigger(args)
	self.selectedTrigger = self.triggerlistBox:GetItem(args);

	-- clear focus
	for i = 1,self.triggerlistBox:GetItemCount() do
		local item = self.triggerlistBox:GetItem(i);	
		item:SetBackColor( listboxBackground );
	end				
	self.selectedTrigger:SetBackColor( Turbine.UI.Color(1, 0.15, 0.25, 0.15) );
end

function OptionsWindow:SelectBlacklistItem(args)
	self.selectedBlacklistItem = self.blacklistListBox:GetItem(args);

	-- clear focus
	for i = 1,self.blacklistListBox:GetItemCount() do
		local item = self.blacklistListBox:GetItem(i);	
		item:SetBackColor( listboxBackground );
	end				
	self.selectedBlacklistItem:SetBackColor( Turbine.UI.Color(1, 0.15, 0.25, 0.15) );
end
